Browse Source

Merge branch 'feature/ultimatebyte-0220'

Conflicts:
	lgsm/functions/command_fastdl.sh
	lgsm/functions/core_getopt.sh
pull/1378/head
Daniel Gibbs 8 years ago
parent
commit
e4c7e36e69
  1. 7
      BladeSymphony/bsserver
  2. 4
      lgsm/functions/command_dev_detect_deps.sh
  3. 4
      lgsm/functions/command_dev_detect_glibc.sh
  4. 4
      lgsm/functions/command_dev_detect_ldd.sh
  5. 622
      lgsm/functions/command_fastdl.sh
  6. 1108
      lgsm/functions/core_getopt.sh
  7. 5
      lgsm/functions/install_server_dir.sh
  8. 12
      lgsm/functions/mods_core.sh

7
BladeSymphony/bsserver

@ -75,6 +75,13 @@ appid="228780"
# Example: "-beta latest_experimental" # Example: "-beta latest_experimental"
branch="" branch=""
## Github Branch Select
# Allows for the use of different function files
# from a different repo and/or branch.
githubuser="GameServerManagers"
githubrepo="LinuxGSM"
githubbranch="master"
## LinuxGSM Server Details ## LinuxGSM Server Details
# Do not edit # Do not edit
gamename="Blade Symphony" gamename="Blade Symphony"

4
lgsm/functions/command_dev_detect_deps.sh

@ -148,4 +148,6 @@ rm -f "${tmpdir}/.depdetect_ubuntu_list_uniq"
rm -f "${tmpdir}/.depdetect_readelf" rm -f "${tmpdir}/.depdetect_readelf"
rm -f "${tmpdir}/.depdetect_unknown" rm -f "${tmpdir}/.depdetect_unknown"
rm -f "${tmpdir}/.depdetect_unknown_uniq" rm -f "${tmpdir}/.depdetect_unknown_uniq"
core_exit.sh

4
lgsm/functions/command_dev_detect_glibc.sh

@ -37,4 +37,6 @@ while IFS= read -r -d $'\0' line; do
done done
echo "" echo ""
cat "${tmpdir}/detect_glibc.tmp"|sort|uniq|sort -r --version-sort cat "${tmpdir}/detect_glibc.tmp"|sort|uniq|sort -r --version-sort
rm "${tmpdir}/detect_glibc.tmp" rm "${tmpdir}/detect_glibc.tmp"
core_exit.sh

4
lgsm/functions/command_dev_detect_ldd.sh

@ -50,4 +50,6 @@ echo "================================="
cat "${tmpdir}/detect_ldd_not_found.tmp" cat "${tmpdir}/detect_ldd_not_found.tmp"
rm "${tmpdir}/detect_ldd.tmp" rm "${tmpdir}/detect_ldd.tmp"
rm "${tmpdir}/detect_ldd_not_found.tmp" rm "${tmpdir}/detect_ldd_not_found.tmp"
core_exit.sh

622
lgsm/functions/command_fastdl.sh

@ -12,7 +12,9 @@ local function_selfname="$(basename $(readlink -f "${BASH_SOURCE[0]}"))"
check.sh check.sh
# Directories # Directories
webdir="${rootdir}/public_html" if [ -z "${webdir}" ]; then
webdir="${rootdir}/public_html"
fi
fastdldir="${webdir}/fastdl" fastdldir="${webdir}/fastdl"
addonsdir="${systemdir}/addons" addonsdir="${systemdir}/addons"
# Server lua autorun dir, used to autorun lua on client connect to the server # Server lua autorun dir, used to autorun lua on client connect to the server
@ -20,302 +22,412 @@ luasvautorundir="${systemdir}/lua/autorun/server"
luafastdlfile="lgsm_cl_force_fastdl.lua" luafastdlfile="lgsm_cl_force_fastdl.lua"
luafastdlfullpath="${luasvautorundir}/${luafastdlfile}" luafastdlfullpath="${luasvautorundir}/${luafastdlfile}"
fn_check_bzip2(){ # Check if bzip2 is installed
# Returns true if not installed if [ -z "$(command -v bzip2)" ]; then
if [ -z "$(command -v bzip2)" ]; then fn_print_fail "bzip2 is not installed"
bzip2installed="0" fn_script_log_fatal "bzip2 is not installed"
fn_print_info "bzip2 is not installed !" core_exit.sh
fn_script_log_info "bzip2 is not installed" fi
echo -en "\n"
sleep 1 # Header
echo "We advise using it" fn_print_header
echo "For more information, see https://github.com/GameServerManagers/LinuxGSM/wiki/FastDL#bzip2-compression" echo "More info: https://git.io/vyk9a"
sleep 2 echo ""
# Prompts user for FastDL creation settings
echo "${commandaction} setup"
echo "================================="
# Prompt for clearing old files if directory was already here
if [ -d "${fastdldir}" ]; then
fn_print_warning_nl "FastDL directory already exists."
echo "${fastdldir}"
echo ""
if fn_prompt_yn "Overwrite existing directory?" Y; then
fn_script_log_info "Overwrite existing directory: YES"
else else
bzip2installed="1" core_exit.sh
fi fi
} fi
fn_fastdl_init(){ # Garry's Mod Specific
# User confirmation if [ "${gamename}" == "Garry's Mod" ]; then
fn_print_ok "Welcome to LGSM's FastDL generator" # Prompt for download enforcer, which is using a .lua addfile resource generator
sleep 1 if fn_prompt_yn "Force clients to download files?" Y; then
echo -en "\n" luaresource="on"
fn_script_log "Started FastDL creation" fn_script_log_info "Force clients to download files: YES"
if ! fn_prompt_yn "Continue?" Y; then else
exit luaresource="off"
fn_script_log_info "Force clients to download filesr: NO"
fi fi
fn_script_log "Initiating FastDL creation" fi
# Check and create directories # Clears any fastdl directory content
if [ ! -d "${webdir}" ]; then fn_clear_old_fastdl(){
echo "" # Clearing old FastDL
fn_print_info "Creating FastDL directories" if [ -d "${fastdldir}" ]; then
echo -en "\n" echo -en "clearing existing FastDL directory ${fastdldir}..."
sleep 1 rm -R "${fastdldir:?}"
fn_print_dots "Creating ${webdir} directory" exitcode=$?
if [ "${exitcode}" -ne 0 ]; then
fn_print_fail_eol_nl
fn_script_log_fatal "Clearing existing FastDL directory ${fastdldir}"
core_exit.sh
else
fn_print_ok_eol_nl
fn_script_log_pass "Clearing existing FastDL directory ${fastdldir}"
fi
sleep 0.5 sleep 0.5
mkdir "${webdir}"
fn_print_ok "Created ${webdir} directory"
fn_script_log "FastDL created ${webdir} directory"
sleep 1
echo -en "\n"
fi
if [ ! -d "${fastdldir}" ]; then
# No directory, won't ask for removing old ones
newfastdl=1
fn_print_dots "Creating fastdl directory"
sleep 0.5
mkdir "${fastdldir}"
fn_print_ok "Created fastdl directory"
fn_script_log "FastDL created fastdl directory"
sleep 1
echo -en "\n"
clearoldfastdl="off" # Nothing to clear
elif [ "$(ls -A "${fastdldir}")" ]; then
newfastdl=0
fi fi
} }
fn_fastdl_config(){ fn_fastdl_dirs(){
# Global settings for FastDL creation # Check and create directories
fn_print_info "Entering configuration" if [ ! -d "${webdir}" ]; then
fn_script_log "Configuration" echo -en "creating web directory ${webdir}..."
sleep 2 mkdir -p "${webdir}"
echo -en "\n" exitcode=$?
# Prompt for clearing old files if directory was already here if [ ${exitcode} -ne 0 ]; then
if [ -n "${newfastdl}" ] && [ "${newfastdl}" == "0" ]; then fn_print_fail_eol_nl
fn_print_dots fn_script_log_fatal "Creating web directory ${webdir}"
if fn_prompt_yn "Clear old FastDL files?" Y; then core_exit.sh
clearoldfastdl="on"; fn_script_log "clearoldfastdl enabled"; fn_print_ok "Clearing Enabled"
else else
clearoldfastdl="off"; fn_script_log "clearoldfastdl disabled"; fn_print_ok "Clearing Disabled" fn_print_ok_eol_nl
fn_script_log_pass "Creating web directory ${webdir}"
fi fi
echo -en "\n" sleep 0.5
fi fi
# Prompt for using bzip2 if it's installed if [ ! -d "${fastdldir}" ]; then
if [ ${bzip2installed} == 1 ]; then echo -en "creating fastdl directory ${fastdldir}..."
fn_print_dots mkdir -p "${fastdldir}"
if fn_prompt_yn "Enable file compression using bzip2?" Y; then exitcode=$?
bzip2enable="on"; fn_script_log "bzip2 enabled"; fn_print_ok "bzip2 Enabled" if [ ${exitcode} -ne 0 ]; then
fn_print_fail_eol_nl
fn_script_log_fatal "Creating fastdl directory ${fastdldir}"
core_exit.sh
else else
bzip2enable="off"; fn_script_log "bzip2 disabled"; fn_print_ok "bzip2 Disabled" fn_print_ok_eol_nl
fn_script_log_pass "Creating fastdl directory ${fastdldir}"
fi fi
echo -en "\n" sleep 0.5
fi fi
} }
fn_fastdl_gmod_config(){ # Using this gist https://gist.github.com/agunnerson-ibm/efca449565a3e7356906
# Prompt for download enforcer, that is using a .lua addfile resource generator fn_human_readable_file_size(){
fn_print_dots local abbrevs=(
if fn_prompt_yn "Use client download enforcer?" Y; then $((1 << 60)):ZB
luaressource="on"; fn_script_log "DL enforcer Enabled"; fn_print_ok "Enforcer Enabled" $((1 << 50)):EB
else $((1 << 40)):TB
luaressource="off"; fn_script_log "DL enforcer Disabled"; fn_print_ok "Enforcer Disabled" $((1 << 30)):GB
fi $((1 << 20)):MB
echo -en "\n" $((1 << 10)):KB
$((1)):bytes
)
local bytes="${1}"
local precision="${2}"
if [[ "${bytes}" == "1" ]]; then
echo "1 byte"
else
for item in "${abbrevs[@]}"; do
local factor="${item%:*}"
local abbrev="${item#*:}"
if [[ "${bytes}" -ge "${factor}" ]]; then
local size="$(bc -l <<< "${bytes} / ${factor}")"
printf "%.*f %s\n" "${precision}" "${size}" "${abbrev}"
break
fi
done
fi
} }
fn_clear_old_fastdl(){ # Provides info about the fastdl directory content and prompts for confirmation
# Clearing old FastDL if user answered yes fn_fastdl_preview(){
if [ "${clearoldfastdl}" == "on" ]; then # Remove any file list
fn_print_info "Clearing existing FastDL directory" if [ -f "${tmpdir}/fastdl_files_to_compress.txt" ]; then
fn_script_log "Clearing existing FastDL directory" rm -f "${tmpdir}/fastdl_files_to_compress.txt"
fi
echo -e "analysing required files"
fn_script_log_info "Analysing required files"
# Garry's Mod
if [ "${gamename}" == "Garry's Mod" ]; then
cd "${systemdir}" || exit
allowed_extentions_array=( "*.ain" "*.bsp" "*.mdl" "*.mp3" "*.ogg" "*.otf" "*.pcf" "*.phy" "*.png" "*.vtf" "*.vmt" "*.vtx" "*.vvd" "*.ttf" "*.wav" )
for allowed_extention in "${allowed_extentions_array[@]}"; do
fileswc=0
tput sc
while read -r ext; do
((fileswc++))
tput rc; tput el
printf "gathering ${allowed_extention} : ${fileswc}..."
echo "${ext}" >> "${tmpdir}/fastdl_files_to_compress.txt"
done < <(find . -type f -iname ${allowed_extention})
if [ ${fileswc} != 0 ]; then
fn_print_ok_eol_nl
fi
done
# Source engine
else
fastdl_directories_array=( "maps" "materials" "models" "particles" "sounds" "resources" )
for directory in "${fastdl_directories_array[@]}"; do
if [ -d "${systemdir}/${directory}" ]; then
if [ "${directory}" == "maps" ]; then
local allowed_extentions_array=( "*.bsp" "*.ain" "*.nav" "*.jpg" "*.txt" )
elif [ "${directory}" == "materials" ]; then
local allowed_extentions_array=( "*.vtf" "*.vmt" "*.vbf" )
elif [ "${directory}" == "models" ]; then
local allowed_extentions_array=( "*.vtx" "*.vvd" "*.mdl" "*.phy" "*.jpg" "*.png" )
elif [ "${directory}" == "particles" ]; then
local allowed_extentions_array=( "*.pcf" )
elif [ "${directory}" == "sounds" ]; then
local allowed_extentions_array=( "*.wav" "*.mp3" "*.ogg" )
fi
for allowed_extention in "${allowed_extentions_array[@]}"; do
fileswc=0
tput sc
while read -r ext; do
((fileswc++))
tput rc; tput el
printf "gathering ${directory} ${allowed_extention} : ${fileswc}..."
echo "${ext}" >> "${tmpdir}/fastdl_files_to_compress.txt"
done < <(find "${systemdir}/${directory}" -type f -iname ${allowed_extention})
tput rc; tput el
printf "gathering ${directory} ${allowed_extention} : ${fileswc}..."
if [ ${fileswc} != 0 ]; then
fn_print_ok_eol_nl
fi
done
fi
done
fi
if [ -f "${tmpdir}/fastdl_files_to_compress.txt" ]; then
echo "calculating total file size..."
sleep 0.5 sleep 0.5
rm -R "${fastdldir:?}"/* totalfiles=$(wc -l < "${tmpdir}/fastdl_files_to_compress.txt")
fn_print_ok "Old FastDL directory cleared" # Calculates total file size
fn_script_log "Old FastDL directory cleared" while read dufile; do
sleep 1 filesize=$(stat -c %s "${dufile}")
echo -en "\n" filesizetotal=$(( ${filesizetotal} + ${filesize} ))
exitcode=$?
if [ "${exitcode}" != 0 ]; then
fn_print_fail_eol_nl
fn_script_log_fatal "Calculating total file size."
core_exit.sh
fi
done <"${tmpdir}/fastdl_files_to_compress.txt"
else
fn_print_fail_eol_nl "generating file list"
fn_script_log_fatal "Generating file list."
core_exit.sh
fi
echo "about to compress ${totalfiles} files, total size $(fn_human_readable_file_size ${filesizetotal} 0)"
fn_script_log_info "${totalfiles} files, total size $(fn_human_readable_file_size ${filesizetotal} 0)"
rm "${tmpdir}/fastdl_files_to_compress.txt"
if ! fn_prompt_yn "Continue?" Y; then
fn_script_log "User exited"
core_exit.sh
fi fi
} }
fn_gmod_fastdl(){ # Builds Garry's Mod fastdl directory content
# Copy all needed files for FastDL fn_fastdl_gmod(){
echo "" cd "${systemdir}" || exit
fn_print_dots "Starting gathering all needed files" for allowed_extention in "${allowed_extentions_array[@]}"
fn_script_log "Starting gathering all needed files" do
sleep 1 fileswc=0
echo -en "\n" tput sc
while read -r fastdlfile; do
# No choice to cd to the directory, as find can't then display relative directory ((fileswc++))
cd "${systemdir}" tput rc; tput el
printf "copying ${allowed_extention} : ${fileswc}..."
# Map Files cp --parents "${fastdlfile}" "${fastdldir}"
fn_print_dots "Copying map files..." exitcode=$?
fn_script_log "Copying map files" if [ ${exitcode} -ne 0 ]; then
sleep 0.5 fn_print_fail_eol_nl
find . -name '*.bsp' | cpio --quiet -updm "${fastdldir}" fn_script_log_fatal "Copying ${fastdlfile} > ${fastdldir}"
find . -name '*.ain' | cpio --quiet -updm "${fastdldir}" core_exit.sh
fn_print_ok "Map files copied" else
sleep 0.5 fn_script_log_pass "Copying ${fastdlfile} > ${fastdldir}"
echo -en "\n" fi
done < <(find . -type f -iname ${allowed_extention})
# Materials if [ ${fileswc} != 0 ]; then
fn_print_dots "Copying materials..." fn_print_ok_eol_nl
fn_script_log "Copying materials" fi
sleep 0.5 done
find . -name '*.vtf' | cpio --quiet -updm "${fastdldir}"
find . -name '*.vmt' | cpio --quiet -updm "${fastdldir}"
fn_print_ok "Materials copied"
sleep 0.5
echo -en "\n"
# Models
fn_print_dots "Copying models..."
fn_script_log "Copying models"
sleep 1
find . -name '*.vtx' | cpio --quiet -updm "${fastdldir}"
find . -name '*.vvd' | cpio --quiet -updm "${fastdldir}"
find . -name '*.mdl' | cpio --quiet -updm "${fastdldir}"
find . -name '*.phy' | cpio --quiet -updm "${fastdldir}"
fn_print_ok "Models copied"
sleep 0.5
echo -en "\n"
# Particles
fn_print_dots "Copying particles..."
fn_script_log "Copying particles"
sleep 0.5
find . -name '*.pcf' | cpio --quiet -updm "${fastdldir}"
fn_print_ok "Particles copied"
sleep 0.5
echo -en "\n"
# Sounds
fn_print_dots "Copying sounds..."
fn_script_log "Copying sounds"
sleep 0.5
find . -name '*.wav' | cpio --quiet -updm "${fastdldir}"
find . -name '*.mp3' | cpio --quiet -updm "${fastdldir}"
find . -name '*.ogg' | cpio --quiet -updm "${fastdldir}"
fn_print_ok "Sounds copied"
sleep 0.5
echo -en "\n"
# Resources (mostly fonts)
fn_print_dots "Copying fonts and png..."
fn_script_log "Copying fonts and png"
sleep 1
find . -name '*.otf' | cpio --quiet -updm "${fastdldir}"
find . -name '*.ttf' | cpio --quiet -updm "${fastdldir}"
find . -name '*.png' | cpio --quiet -updm "${fastdldir}"
fn_print_ok "Fonts and png copied"
sleep 0.5
echo -en "\n"
# Going back to rootdir in order to prevent mistakes
cd "${rootdir}"
# Correct addons directory structure for FastDL # Correct addons directory structure for FastDL
if [ -d "${fastdldir}/addons" ]; then if [ -d "${fastdldir}/addons" ]; then
fn_print_info "Adjusting addons' file structure" echo -en "updating addons file structure..."
fn_script_log "Adjusting addon's file structure"
sleep 1
cp -Rf "${fastdldir}"/addons/*/* "${fastdldir}" cp -Rf "${fastdldir}"/addons/*/* "${fastdldir}"
#Don't remove yet rm -R "${fastdldir:?}/addons" exitcode=$?
fn_print_ok "Adjusted addon's file structure" if [ ${exitcode} -ne 0 ]; then
fn_print_fail_eol_nl
fn_script_log_fatal "Updating addons file structure"
core_exit.sh
else
fn_print_ok_eol_nl
fn_script_log_pass "Updating addons file structure"
fi
# Clear addons directory in fastdl
echo -en "clearing addons dir from fastdl dir..."
sleep 1 sleep 1
echo -en "\n" rm -R "${fastdldir:?}/addons"
exitcode=$?
if [ ${exitcode} -ne 0 ]; then
fn_print_fail_eol_nl
fn_script_log_fatal "Clearing addons dir from fastdl dir"
core_exit.sh
else
fn_print_ok_eol_nl
fn_script_log_pass "Clearing addons dir from fastdl dir"
fi
fi fi
# Correct content that may be into a lua directory by mistake like some darkrpmodification addons # Correct content that may be into a lua directory by mistake like some darkrpmodification addons
if [ -d "${fastdldir}/lua" ]; then if [ -d "${fastdldir}/lua" ]; then
fn_print_dots "Typical DarkRP shit detected, fixing" echo -en "correcting DarkRP files..."
sleep 2 sleep 2
cp -Rf "${fastdldir}/lua/"* "${fastdldir}" cp -Rf "${fastdldir}/lua/"* "${fastdldir}"
fn_print_ok "Stupid DarkRP file structure fixed" exitcode=$?
sleep 2 if [ ${exitcode} -ne 0 ]; then
echo -en "\n" fn_print_fail_eol_nl
fn_script_log_fatal "Correcting DarkRP files"
core_exit.sh
else
fn_print_ok_eol_nl
fn_script_log_pass "Correcting DarkRP files"
fi
fi
if [ -f "${tmpdir}/fastdl_files_to_compress.txt" ]; then
totalfiles=$(wc -l < "${tmpdir}/fastdl_files_to_compress.txt")
# Calculates total file size
while read dufile; do
filesize=$(du -b "${dufile}"| awk '{ print $1 }')
filesizetotal=$(( ${filesizetotal} + ${filesize} ))
done <"${tmpdir}/fastdl_files_to_compress.txt"
fi fi
} }
# Generate lua file that will force download any file into the FastDL directory fn_fastdl_source(){
fn_lua_fastdl(){ for directory in "${fastdl_directories_array[@]}"
# Remove lua file if luaressource is turned off and file exists do
echo "" if [ -d "${systemdir}/${directory}" ]; then
if [ "${luaressource}" == "off" ]; then if [ "${directory}" == "maps" ]; then
if [ -f "${luafastdlfullpath}" ]; then local allowed_extentions_array=( "*.bsp" "*.ain" "*.nav" "*.jpg" "*.txt" )
fn_print_dots "Removing download enforcer" elif [ "${directory}" == "materials" ]; then
sleep 1 local allowed_extentions_array=( "*.vtf" "*.vmt" "*.vbf" )
rm -R "${luafastdlfullpath:?}" elif [ "${directory}" == "models" ]; then
fn_print_ok "Removed download enforcer" local allowed_extentions_array=( "*.vtx" "*.vvd" "*.mdl" "*.phy" "*.jpg" "*.png" )
fn_script_log "Removed old download inforcer" elif [ "${directory}" == "particles" ]; then
echo -en "\n" local allowed_extentions_array=( "*.pcf" )
sleep 2 elif [ "${directory}" == "sounds" ]; then
local allowed_extentions_array=( "*.wav" "*.mp3" "*.ogg" )
fi
for allowed_extention in "${allowed_extentions_array[@]}"
do
fileswc=0
tput sc
while read -r fastdlfile; do
((fileswc++))
tput rc; tput el
printf "copying ${directory} ${allowed_extention} : ${fileswc}..."
sleep 0.01
if [ ! -d "${fastdldir}/${directory}" ]; then
mkdir "${fastdldir}/${directory}"
fi
cp "${fastdlfile}" "${fastdldir}/${directory}"
exitcode=$?
if [ "${exitcode}" -ne 0 ]; then
fn_print_fail_eol_nl
fn_script_log_fatal "Copying ${fastdlfile} > ${fastdldir}/${directory}"
core_exit.sh
else
fn_script_log_pass "Copying ${fastdlfile} > ${fastdldir}/${directory}"
fi
done < <(find "${systemdir}/${directory}" -type f -iname ${allowed_extention})
if [ ${fileswc} != 0 ]; then
fn_print_ok_eol_nl
fi
done
fi fi
done
}
# Builds the fastdl directory content
fn_fastdl_build(){
# Copy all needed files for FastDL
echo -e "copying files to ${fastdldir}"
fn_script_log_info "Copying files to ${fastdldir}"
if [ "${gamename}" == "Garry's Mod" ]; then
fn_fastdl_gmod
fn_fastdl_gmod_dl_enforcer
else
fn_fastdl_source
fi fi
# Remove old lua file and generate a new one if user said yes }
if [ "${luaressource}" == "on" ]; then
if [ -f "${luafastdlfullpath}" ]; then # Generate lua file that will force download any file into the FastDL directory
fn_print_dots "Removing old download enforcer" fn_fastdl_gmod_dl_enforcer(){
sleep 1 # Clear old lua file
rm "${luafastdlfullpath}" if [ -f "${luafastdlfullpath}" ]; then
fn_print_ok "Removed old download enforcer" echo -en "removing existing download enforcer: ${luafastdlfile}..."
fn_script_log "Removed old download enforcer" rm "${luafastdlfullpath:?}"
echo -en "\n" exitcode=$?
sleep 1 if [ "${exitcode}" -ne 0 ]; then
fn_print_fail_eol_nl
fn_script_log_fatal "Removing existing download enforcer ${luafastdlfullpath}"
core_exit.sh
else
fn_print_ok_eol_nl
fn_script_log_pass "Removing existing download enforcer ${luafastdlfullpath}"
fi fi
fn_print_dots "Generating new download enforcer" fi
fn_script_log "Generating new download enforcer" # Generate new one if user said yes
sleep 1 if [ "${luaresource}" == "on" ]; then
echo -en "creating new download enforcer: ${luafastdlfile}..."
touch "${luafastdlfullpath}"
# Read all filenames and put them into a lua file at the right path # Read all filenames and put them into a lua file at the right path
find "${fastdldir}" \( -type f ! -name "*.bz2" \) -printf '%P\n' | while read line; do while read line; do
echo "resource.AddFile( "\""${line}"\"" )" >> ${luafastdlfullpath} echo "resource.AddFile( \"${line}\" )" >> "${luafastdlfullpath}"
done done < <(find "${fastdldir:?}" \( -type f ! -name "*.bz2" \) -printf '%P\n')
fn_print_ok "Download enforcer generated" exitcode=$?
fn_script_log "Download enforcer generated" if [ "${exitcode}" -ne 0 ]; then
echo -en "\n" fn_print_fail_eol_nl
echo "" fn_script_log_fatal "Creating new download enforcer ${luafastdlfullpath}"
sleep 2 core_exit.sh
else
fn_print_ok_eol_nl
fn_script_log_pass "Creating new download enforcer ${luafastdlfullpath}"
fi
fi fi
} }
# Compresses FastDL files using bzip2
fn_fastdl_bzip2(){ fn_fastdl_bzip2(){
# Compressing using bzip2 if user said yes while read -r filetocompress; do
echo "" echo -en "\r\033[Kcompressing ${filetocompress}..."
if [ ${bzip2enable} == "on" ]; then bzip2 -f "${filetocompress}"
fn_print_info "Have a break, this step could take a while..." exitcode=$?
echo -en "\n" if [ "${exitcode}" -ne 0 ]; then
echo "" fn_print_fail_eol_nl
fn_print_dots "Compressing files using bzip2..." fn_script_log_fatal "Compressing ${filetocompress}"
fn_script_log "Compressing files using bzip2..." core_exit.sh
# bzip2 all files that are not already compressed (keeping original files) else
find "${fastdldir}" \( -type f ! -name "*.bz2" \) -exec bzip2 -qk \{\} \; fn_script_log_pass "Compressing ${filetocompress}"
fn_print_ok "bzip2 compression done" fi
fn_script_log "bzip2 compression done" done < <(find "${fastdldir:?}" \( -type f ! -name "*.bz2" \))
sleep 1 fn_print_ok_eol_nl
echo -en "\n"
fi
}
fn_fastdl_completed(){
# Finished message
echo ""
fn_print_ok "Congratulations, it's done!"
fn_script_log "FastDL job done"
sleep 2
echo -en "\n"
echo ""
fn_print_info "Need more documentation? See https://github.com/GameServerManagers/LinuxGSM/wiki/FastDL"
echo -en "\n"
if [ "$bzip2installed" == "0" ]; then
echo "By the way, you'd better install bzip2 and re-run this command!"
fi
echo "Credits : UltimateByte"
} }
# Game checking and functions running # Run functions
# Garry's Mod fn_fastdl_preview
if [ "${gamename}" == "Garry's Mod" ]; then fn_clear_old_fastdl
fn_check_bzip2 fn_fastdl_dirs
fn_fastdl_init fn_fastdl_build
fn_fastdl_config fn_fastdl_bzip2
fn_fastdl_gmod_config # Finished message
fn_clear_old_fastdl echo "FastDL files are located in:"
fn_gmod_fastdl echo "${fastdldir}"
fn_lua_fastdl echo "FastDL completed"
fn_fastdl_bzip2 fn_script_log_info "FastDL completed"
fn_fastdl_completed core_exit.sh
exit
fi

1108
lgsm/functions/core_getopt.sh

File diff suppressed because it is too large

5
lgsm/functions/install_server_dir.sh

@ -12,12 +12,11 @@ echo ""
echo "Server Directory" echo "Server Directory"
echo "=================================" echo "================================="
sleep 1 sleep 1
echo ""
pwd
echo ""
if [ -d "${filesdir}" ]; then if [ -d "${filesdir}" ]; then
fn_print_warning_nl "A server is already installed here." fn_print_warning_nl "A server is already installed here."
fi fi
pwd
echo ""
if [ -z "${autoinstall}" ]; then if [ -z "${autoinstall}" ]; then
if ! fn_prompt_yn "Continue?" Y; then if ! fn_prompt_yn "Continue?" Y; then
exit exit

12
lgsm/functions/mods_core.sh

@ -42,7 +42,7 @@ fn_mod_lowercase(){
echo -ne "converting ${modprettyname} files to lowercase..." echo -ne "converting ${modprettyname} files to lowercase..."
sleep 0.5 sleep 0.5
fn_script_log_info "Converting ${modprettyname} files to lowercase" fn_script_log_info "Converting ${modprettyname} files to lowercase"
files=$(find "${extractdir}" -depth | wc -l) fileswc=$(find "${extractdir}" -depth | wc -l)
echo -en "\r" echo -en "\r"
while read -r src; do while read -r src; do
dst=`dirname "${src}"`/`basename "${src}" | tr '[A-Z]' '[a-z]'` dst=`dirname "${src}"`/`basename "${src}" | tr '[A-Z]' '[a-z]'`
@ -52,10 +52,10 @@ fn_mod_lowercase(){
local exitcode=$? local exitcode=$?
((renamedwc++)) ((renamedwc++))
fi fi
echo -ne "${renamedwc} / ${totalfileswc} / $files converting ${modprettyname} files to lowercase..." $'\r' echo -ne "${renamedwc} / ${totalfileswc} / ${fileswc} converting ${modprettyname} files to lowercase..." $'\r'
((totalfileswc++)) ((totalfileswc++))
done < <(find "${extractdir}" -depth) done < <(find "${extractdir}" -depth)
echo -ne "${renamedwc} / ${totalfileswc} / $files converting ${modprettyname} files to lowercase..." echo -ne "${renamedwc} / ${totalfileswc} / ${fileswc} converting ${modprettyname} files to lowercase..."
if [ ${exitcode} -ne 0 ]; then if [ ${exitcode} -ne 0 ]; then
fn_print_fail_eol_nl fn_print_fail_eol_nl
@ -346,7 +346,7 @@ fn_mod_compatible_test(){
fn_create_mods_dir(){ fn_create_mods_dir(){
# Create lgsm data modsdir # Create lgsm data modsdir
if [ ! -d "${modsdir}" ];then if [ ! -d "${modsdir}" ];then
echo "creating lgsm mods data directory ${modsdir}..." echo -en "creating LinuxGSM mods data directory ${modsdir}..."
mkdir -p "${modsdir}" mkdir -p "${modsdir}"
exitcode=$? exitcode=$?
if [ ${exitcode} -ne 0 ]; then if [ ${exitcode} -ne 0 ]; then
@ -361,7 +361,7 @@ fn_create_mods_dir(){
fi fi
# Create mod install directory # Create mod install directory
if [ ! -d "${modinstalldir}" ]; then if [ ! -d "${modinstalldir}" ]; then
echo "creating mods install directory ${modinstalldir}..." echo -en "creating mods install directory ${modinstalldir}..."
mkdir -p "${modinstalldir}" mkdir -p "${modinstalldir}"
exitcode=$? exitcode=$?
if [ ${exitcode} -ne 0 ]; then if [ ${exitcode} -ne 0 ]; then
@ -438,7 +438,7 @@ fn_mods_check_installed(){
if [ ${installedmodscount} -eq 0 ]; then if [ ${installedmodscount} -eq 0 ]; then
echo "" echo ""
fn_print_failure_nl "No installed mods or addons were found" fn_print_failure_nl "No installed mods or addons were found"
echo " * Install mods using LGSM first with: ./${selfname} mods-install" echo " * Install mods using LinuxGSM first with: ./${selfname} mods-install"
fn_script_log_error "No installed mods or addons were found." fn_script_log_error "No installed mods or addons were found."
core_exit.sh core_exit.sh
fi fi

Loading…
Cancel
Save